Index: trunk/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/source/include/tsar_xbar_cluster.h
===================================================================
--- trunk/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/source/include/tsar_xbar_cluster.h	(revision 396)
+++ trunk/platforms/tsar_generic_xbar/tsar_xbar_cluster/caba/source/include/tsar_xbar_cluster.h	(revision 428)
@@ -1,5 +1,5 @@
 //////////////////////////////////////////////////////////////////////////////
 // File: tsar_xbar_cluster.h
-// Author: Alain Greiner 
+// Author: Alain Greiner
 // Copyright: UPMC/LIP6
 // Date : march 2013
@@ -38,7 +38,7 @@
 ///////////////////////////////////////////////////////////////////////////
 template<size_t dspin_cmd_width,
-         size_t dspin_rsp_width, 
+         size_t dspin_rsp_width,
          typename vci_param_int,
-         typename vci_param_ext>  class TsarXbarCluster 
+         typename vci_param_ext>  class TsarXbarCluster
 ///////////////////////////////////////////////////////////////////////////
     : public soclib::caba::BaseModule
@@ -46,82 +46,82 @@
     public:
 
-	// Ports
-    sc_in<bool>                             		p_clk;
-    sc_in<bool>                             		p_resetn;
-	soclib::caba::DspinOutput<dspin_cmd_width>   	**p_cmd_out;
-	soclib::caba::DspinInput<dspin_cmd_width>    	**p_cmd_in;
-    soclib::caba::DspinOutput<dspin_rsp_width>     	**p_rsp_out;
-    soclib::caba::DspinInput<dspin_rsp_width>      	**p_rsp_in;
+    // Ports
+    sc_in<bool>                                     p_clk;
+    sc_in<bool>                                     p_resetn;
+    soclib::caba::DspinOutput<dspin_cmd_width>      **p_cmd_out;
+    soclib::caba::DspinInput<dspin_cmd_width>       **p_cmd_in;
+    soclib::caba::DspinOutput<dspin_rsp_width>      **p_rsp_out;
+    soclib::caba::DspinInput<dspin_rsp_width>       **p_rsp_in;
 
     // interrupt signals
-	sc_signal<bool>     	signal_false;
-	sc_signal<bool> 		signal_proc_it[8];
-	sc_signal<bool> 		signal_irq_mdma[8];
-	sc_signal<bool>			signal_irq_mtty[23];
-	sc_signal<bool> 		signal_irq_mnic_rx[8];	// unused
-	sc_signal<bool> 		signal_irq_mnic_tx[8];	// unused
-	sc_signal<bool> 		signal_irq_bdev;
-	
-	// DSPIN signals between DSPIN routers and local_crossbars
-	DspinSignals<dspin_cmd_width> 	signal_dspin_cmd_l2g_d; 
-	DspinSignals<dspin_cmd_width> 	signal_dspin_cmd_g2l_d; 
-	DspinSignals<dspin_cmd_width> 	signal_dspin_m2p_l2g_c;
-	DspinSignals<dspin_cmd_width> 	signal_dspin_m2p_g2l_c; 
-	DspinSignals<dspin_rsp_width> 	signal_dspin_rsp_l2g_d; 
-	DspinSignals<dspin_rsp_width> 	signal_dspin_rsp_g2l_d; 
-	DspinSignals<dspin_rsp_width> 	signal_dspin_p2m_l2g_c;
-	DspinSignals<dspin_rsp_width> 	signal_dspin_p2m_g2l_c;
-
-	// Direct VCI signals to VCI/DSPIN wrappers
-	VciSignals<vci_param_int> 		signal_vci_ini_proc[8]; 
-	VciSignals<vci_param_int>  		signal_vci_ini_mdma; 
-	VciSignals<vci_param_int>  		signal_vci_ini_bdev; 
-
-	VciSignals<vci_param_int>		signal_vci_tgt_memc;
-	VciSignals<vci_param_int> 		signal_vci_tgt_xicu;
-	VciSignals<vci_param_int> 		signal_vci_tgt_mdma;
-	VciSignals<vci_param_int> 		signal_vci_tgt_mtty;
-	VciSignals<vci_param_int> 		signal_vci_tgt_bdev;
-	VciSignals<vci_param_int> 		signal_vci_tgt_brom;
-	VciSignals<vci_param_int> 		signal_vci_tgt_fbuf;
-	VciSignals<vci_param_int> 		signal_vci_tgt_mnic;
-
-	// Direct DSPIN signals to local crossbars
-	DspinSignals<dspin_cmd_width>     signal_dspin_cmd_proc_i[8];
-	DspinSignals<dspin_rsp_width>     signal_dspin_rsp_proc_i[8];
-	DspinSignals<dspin_cmd_width>     signal_dspin_cmd_mdma_i;
-	DspinSignals<dspin_rsp_width>     signal_dspin_rsp_mdma_i;
-	DspinSignals<dspin_cmd_width>     signal_dspin_cmd_bdev_i;
-	DspinSignals<dspin_rsp_width>     signal_dspin_rsp_bdev_i;
-
-	DspinSignals<dspin_cmd_width>     signal_dspin_cmd_memc_t;
-	DspinSignals<dspin_rsp_width>     signal_dspin_rsp_memc_t;
-	DspinSignals<dspin_cmd_width>     signal_dspin_cmd_xicu_t;
-	DspinSignals<dspin_rsp_width>     signal_dspin_rsp_xicu_t;
-	DspinSignals<dspin_cmd_width>     signal_dspin_cmd_mdma_t;
-	DspinSignals<dspin_rsp_width>     signal_dspin_rsp_mdma_t;
-	DspinSignals<dspin_cmd_width>     signal_dspin_cmd_mtty_t;
-	DspinSignals<dspin_rsp_width>     signal_dspin_rsp_mtty_t;
-	DspinSignals<dspin_cmd_width>     signal_dspin_cmd_bdev_t;
-	DspinSignals<dspin_rsp_width>     signal_dspin_rsp_bdev_t;
-	DspinSignals<dspin_cmd_width>     signal_dspin_cmd_brom_t;
-	DspinSignals<dspin_rsp_width>     signal_dspin_rsp_brom_t;
-	DspinSignals<dspin_cmd_width>     signal_dspin_cmd_fbuf_t;
-	DspinSignals<dspin_rsp_width>     signal_dspin_rsp_fbuf_t;
-	DspinSignals<dspin_cmd_width>     signal_dspin_cmd_mnic_t;
-	DspinSignals<dspin_rsp_width>     signal_dspin_rsp_mnic_t;
-
-	// Coherence DSPIN signals to local crossbar
-	DspinSignals<dspin_cmd_width>     signal_dspin_m2p_memc;
-	DspinSignals<dspin_rsp_width>     signal_dspin_p2m_memc;
-	DspinSignals<dspin_cmd_width>     signal_dspin_m2p_proc[8];
-	DspinSignals<dspin_rsp_width>     signal_dspin_p2m_proc[8];
-
-	// external RAM to MEMC VCI signal
-	VciSignals<vci_param_ext>         signal_vci_xram;
-	
+    sc_signal<bool>         signal_false;
+    sc_signal<bool>         signal_proc_it[8];
+    sc_signal<bool>         signal_irq_mdma[8];
+    sc_signal<bool>         signal_irq_mtty[23];
+    sc_signal<bool>         signal_irq_mnic_rx[8];  // unused
+    sc_signal<bool>         signal_irq_mnic_tx[8];  // unused
+    sc_signal<bool>         signal_irq_bdev;
+
+    // DSPIN signals between DSPIN routers and local_crossbars
+    DspinSignals<dspin_cmd_width>   signal_dspin_cmd_l2g_d;
+    DspinSignals<dspin_cmd_width>   signal_dspin_cmd_g2l_d;
+    DspinSignals<dspin_cmd_width>   signal_dspin_m2p_l2g_c;
+    DspinSignals<dspin_cmd_width>   signal_dspin_m2p_g2l_c;
+    DspinSignals<dspin_rsp_width>   signal_dspin_rsp_l2g_d;
+    DspinSignals<dspin_rsp_width>   signal_dspin_rsp_g2l_d;
+    DspinSignals<dspin_rsp_width>   signal_dspin_p2m_l2g_c;
+    DspinSignals<dspin_rsp_width>   signal_dspin_p2m_g2l_c;
+
+    // Direct VCI signals to VCI/DSPIN wrappers
+    VciSignals<vci_param_int>       signal_vci_ini_proc[8];
+    VciSignals<vci_param_int>       signal_vci_ini_mdma;
+    VciSignals<vci_param_int>       signal_vci_ini_bdev;
+
+    VciSignals<vci_param_int>       signal_vci_tgt_memc;
+    VciSignals<vci_param_int>       signal_vci_tgt_xicu;
+    VciSignals<vci_param_int>       signal_vci_tgt_mdma;
+    VciSignals<vci_param_int>       signal_vci_tgt_mtty;
+    VciSignals<vci_param_int>       signal_vci_tgt_bdev;
+    VciSignals<vci_param_int>       signal_vci_tgt_brom;
+    VciSignals<vci_param_int>       signal_vci_tgt_fbuf;
+    VciSignals<vci_param_int>       signal_vci_tgt_mnic;
+
+    // Direct DSPIN signals to local crossbars
+    DspinSignals<dspin_cmd_width>     signal_dspin_cmd_proc_i[8];
+    DspinSignals<dspin_rsp_width>     signal_dspin_rsp_proc_i[8];
+    DspinSignals<dspin_cmd_width>     signal_dspin_cmd_mdma_i;
+    DspinSignals<dspin_rsp_width>     signal_dspin_rsp_mdma_i;
+    DspinSignals<dspin_cmd_width>     signal_dspin_cmd_bdev_i;
+    DspinSignals<dspin_rsp_width>     signal_dspin_rsp_bdev_i;
+
+    DspinSignals<dspin_cmd_width>     signal_dspin_cmd_memc_t;
+    DspinSignals<dspin_rsp_width>     signal_dspin_rsp_memc_t;
+    DspinSignals<dspin_cmd_width>     signal_dspin_cmd_xicu_t;
+    DspinSignals<dspin_rsp_width>     signal_dspin_rsp_xicu_t;
+    DspinSignals<dspin_cmd_width>     signal_dspin_cmd_mdma_t;
+    DspinSignals<dspin_rsp_width>     signal_dspin_rsp_mdma_t;
+    DspinSignals<dspin_cmd_width>     signal_dspin_cmd_mtty_t;
+    DspinSignals<dspin_rsp_width>     signal_dspin_rsp_mtty_t;
+    DspinSignals<dspin_cmd_width>     signal_dspin_cmd_bdev_t;
+    DspinSignals<dspin_rsp_width>     signal_dspin_rsp_bdev_t;
+    DspinSignals<dspin_cmd_width>     signal_dspin_cmd_brom_t;
+    DspinSignals<dspin_rsp_width>     signal_dspin_rsp_brom_t;
+    DspinSignals<dspin_cmd_width>     signal_dspin_cmd_fbuf_t;
+    DspinSignals<dspin_rsp_width>     signal_dspin_rsp_fbuf_t;
+    DspinSignals<dspin_cmd_width>     signal_dspin_cmd_mnic_t;
+    DspinSignals<dspin_rsp_width>     signal_dspin_rsp_mnic_t;
+
+    // Coherence DSPIN signals to local crossbar
+    DspinSignals<dspin_cmd_width>     signal_dspin_m2p_memc;
+    DspinSignals<dspin_rsp_width>     signal_dspin_p2m_memc;
+    DspinSignals<dspin_cmd_width>     signal_dspin_m2p_proc[8];
+    DspinSignals<dspin_rsp_width>     signal_dspin_p2m_proc[8];
+
+    // external RAM to MEMC VCI signal
+    VciSignals<vci_param_ext>         signal_vci_xram;
+
     // Components
 
-    VciCcVCacheWrapper<vci_param_int, 
+    VciCcVCacheWrapper<vci_param_int,
                        dspin_cmd_width,
                        dspin_rsp_width,
@@ -132,7 +132,7 @@
                              dspin_rsp_width>*    wi_proc[8];
 
-    VciMemCache<vci_param_int, 
-                vci_param_ext, 
-                dspin_rsp_width, 
+    VciMemCache<vci_param_int,
+                vci_param_ext,
+                dspin_rsp_width,
                 dspin_cmd_width>*                 memc;
 
@@ -201,8 +201,8 @@
     VirtualDspinRouter<dspin_rsp_width>*          router_rsp;
 
-	TsarXbarCluster( sc_module_name                     insname,
-                     size_t                             nb_procs,      // processors 
-                     size_t                             nb_ttys,       // TTY terminals 
-                     size_t                             nb_dmas,       //  DMA channels 
+    TsarXbarCluster( sc_module_name                     insname,
+                     size_t                             nb_procs,      // processors
+                     size_t                             nb_ttys,       // TTY terminals
+                     size_t                             nb_dmas,       //  DMA channels
                      size_t                             x,             // x coordinate
                      size_t                             y,             // y coordinate
@@ -210,9 +210,9 @@
                      const soclib::common::MappingTable &mtd,          // internal
                      const soclib::common::MappingTable &mtx,          // external
-                     size_t	                            x_width,       // x field bits
-                     size_t	                            y_width,       // y field bits
-                     size_t	                            l_width,       // l field bits
-                     size_t	                            tgtid_memc,
-                     size_t	                            tgtid_xicu,
+                     size_t                             x_width,       // x field bits
+                     size_t                             y_width,       // y field bits
+                     size_t                             l_width,       // l field bits
+                     size_t                             tgtid_memc,
+                     size_t                             tgtid_xicu,
                      size_t                             tgtid_mdma,
                      size_t                             tgtid_fbuf,
@@ -224,22 +224,22 @@
                      size_t                             memc_sets,
                      size_t                             l1_i_ways,
-                     size_t                             l1_i_sets, 
+                     size_t                             l1_i_sets,
                      size_t                             l1_d_ways,
-                     size_t                             l1_d_sets,  
-                     size_t                             xram_latency,  // external ram 
-                     bool                               io,	           // I/O cluster
+                     size_t                             l1_d_sets,
+                     size_t                             xram_latency,  // external ram
+                     bool                               io,            // I/O cluster
                      size_t                             xfb,           // fbf pixels
                      size_t                             yfb,           // fbf lines
-                     char*                              disk_name,     // virtual disk 
-                     size_t                             block_size,    // block size 
+                     char*                              disk_name,     // virtual disk
+                     size_t                             block_size,    // block size
                      size_t                             nic_channels,  // number channels
-                     char*                              nic_rx_name,   // filename rx 
-                     char*                              nic_tx_name,   // filename tx 
-                     uint32_t							nic_timeout,   // cycles
-			         const Loader                       &loader,       
-                     uint32_t                           frozen_cycles, 
+                     char*                              nic_rx_name,   // filename rx
+                     char*                              nic_tx_name,   // filename tx
+                     uint32_t                           nic_timeout,   // cycles
+                     const Loader                       &loader,
+                     uint32_t                           frozen_cycles,
                      uint32_t                           start_debug_cycle,
-                     bool                               memc_debug_ok, 
-                     bool                               proc_debug_ok); 
+                     bool                               memc_debug_ok,
+                     bool                               proc_debug_ok);
 
 };